# Author: Darrell Christmas
# Last Updated: 10/01/08
# Enemy manager will load enemies and give them unique id numbers, release them from the world, and such
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import *
from Character.Rat import Rat

class EnemyManager(DirectObject):
    def __init__(self, parentObject):
        self.array = []
        self.currentId = 0
        self.parent = parentObject
        self.player = parentObject.s
        self.loadRats()
        return None
    
    #load enemy    
    def loadEnemy(self, position, heading, isStanding):
        #position = vec3(-93,10,64.5)
        #print self.currentId
        enemy = Rat(self.parent, self.player, self.currentId, position, heading, isStanding)
        
        self.currentId = self.currentId +1
        return enemy
    
    
    def reloadEnemy(self, position, heading, isStanding, id):
        #position = vec3(-93,10,64.5)
        #print self.currentId
        enemy = Rat(self.parent, self.player, id, position, heading, isStanding)
        
        
        return enemy
    
    #load enemy rats. 
    #TODO: this will be entered differently, not in the main soon
    def loadRats(self):
      position = Point3(-93,-40,64.5)
      self.array.append(self.loadEnemy(position, 180, False))
      
      position = Point3(-98,-30,64.5)
      self.array.append(self.loadEnemy(position, 0, True))
      
      #position = Point3(-98,-35,64.5)
      #self.array.append(self.loadEnemy(position, 90))
      
      return None
  
    def loadRatslvl2(self):
        self.sendToLalaLand()
        
        position = Point3(-1.8,6.8,28)
        self.array.append(self.loadEnemy(position, 270, True))
     
        
        
        position = Point3(-84,30.5,28)
        self.array.append(self.loadEnemy(position, 90, False))
        
        position = Point3(-96.5,20.5,28)
        self.array.append( self.loadEnemy(position, 0, False))
        return None
    
    def loadRatslvl3(self):
        self.sendToLalaLand()
        
        position = Point3(-25.7,-16.6,18)
        self.array.append(self.loadEnemy(position, 0, False))
      
        position = Point3(-60,-23,18)
        self.array.append(self.loadEnemy(position, 0, False))
        
        position = Point3(-82,-57,18)
        self.array.append(self.loadEnemy(position, 270, True))
        return None
    
    def sendToLalaLand(self):
        for i in range(len(self.array)):
            self.parent.colMan.removeCollider(self.array[i].fromObject)
            self.parent.colMan.removeCollider(self.array[i].cSolid)
            self.array[i].actor.hide()
            self.array[i].actor.setPos(200,200,200)
        return None
    