
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import *
from direct.task import Task
class Events(DirectObject):
    def __init__(self, parentObject):
        self.parent = parentObject
        self.roofTrigger = False
        self.gameOver = False
        self.gameOverDead = False
        self.gameOverCaught = False
        self.diamondEvent = False
        self.exitDoorEvent = False
        
        taskMgr.add(self.checkGameOverTask,"checkGameOverTask")
        return None
    
    def loadRoofExitEventTrigger(self):
      self.roofTrigger1 = render.attachNewNode("roofTrigger1")
      self.roofTrigger2 = render.attachNewNode("roofTrigger2")
      self.roofTrigger3 = render.attachNewNode("roofTrigger3")
      self.roofTrigger4 = render.attachNewNode("roofTrigger4")
      self.roofTrigger1.setPos(-20,-23,65)
      self.roofTrigger2.setPos(-20,-47,65)
      self.roofTrigger3.setPos(-47,-47,65)
      self.roofTrigger4.setPos(-47,-23,65)
      self.rCNode1 = self.roofTrigger1.attachNewNode(CollisionNode('roofTrigger'))
      self.rCNode1.node().addSolid(CollisionSphere(0,0,0.5,1))
      #self.rCNode1.show()
      self.rCNode2 = self.roofTrigger2.attachNewNode(CollisionNode('roofTrigger'))
      self.rCNode2.node().addSolid(CollisionSphere(0,0,0.5,1))
      #self.rCNode2.show()
      self.rCNode3 = self.roofTrigger3.attachNewNode(CollisionNode('roofTrigger'))
      self.rCNode3.node().addSolid(CollisionSphere(0,0,0.5,1))
      #self.rCNode3.show()
      self.rCNode4 = self.roofTrigger4.attachNewNode(CollisionNode('roofTrigger'))
      self.rCNode4.node().addSolid(CollisionSphere(0,0,0.5,1))
      #self.rCNode4.show()
      
      
      return None
  
    def doRoofExitEvent(self):
        if (self.roofTrigger == False):
            self.parent.s.dropToTunnel()
            self.parent.createFog()
            self.roofTrigger1.removeNode()
            self.roofTrigger2.removeNode()
            self.roofTrigger3.removeNode()
            self.roofTrigger4.removeNode()
            base.camera.setPos(0,12,6)
            #base.camera.setHpr(180,-5,0)
            self.roofTrigger = True
            self.parent.soundMan.stopRoofConversation()
            self.parent.enemyMan.loadRatslvl2()
            self.loadTunnelEvents()
        return None
    def loadTunnelEvents(self):
        self.tunnelConvo1 = render.attachNewNode("tunnelConvo1")
        self.tunnelConvo2 = render.attachNewNode("tunnelConvo2")
        self.tunnelConvo3 = render.attachNewNode("tunnelConvo3")
        self.ventExitEvent = render.attachNewNode("ventExitEvent")
        self.vCNode1 = self.tunnelConvo1.attachNewNode(CollisionNode('ventTrigger1'))
        self.vCNode2 = self.tunnelConvo2.attachNewNode(CollisionNode('ventTrigger2'))
        self.vCNode3 = self.tunnelConvo3.attachNewNode(CollisionNode('ventTrigger3'))
        self.vECNode = self.ventExitEvent.attachNewNode(CollisionNode('ventExitTrigger'))
        self.vCNode1.node().addSolid(CollisionSphere(0,0,0,2))
        self.vCNode2.node().addSolid(CollisionSphere(0,0,0,2))
        self.vCNode3.node().addSolid(CollisionSphere(0,0,0,2))
        self.vECNode.node().addSolid(CollisionSphere(0,0,0,2))
        self.vCNode1.setPos(0,-9,46)
        self.vCNode2.setPos(-29,32,30)
        self.vCNode3.setPos(-63,42,30)
        self.vECNode.setPos(-96,-2,20)
        #self.vCNode1.show()
        #self.vCNode2.show()
        #self.vCNode3.show()
        #self.vECNode.show()
        return None
    
    def doVentConvoEvent(self, name):
        if (name == "ventTrigger1"):
            self.parent.soundMan.playVentConvo1()
        elif (name == "ventTrigger2"):
            self.parent.soundMan.playVentConvo2()
        elif (name == "ventTrigger3"):
            self.parent.soundMan.playVentConvo3()
        return None
    
    def doVentExit(self):
        base.camera.setPos(0,35,12)
        self.tunnelConvo1.removeNode()
        self.tunnelConvo2.removeNode()
        self.tunnelConvo3.removeNode()
        self.ventExitEvent.removeNode()
        self.parent.enemyMan.loadRatslvl3()
        self.loadDiamondEvent()
        return None
    def loadDiamondEvent(self):
        self.diamondNode = render.attachNewNode('diamondNode')
        self.diamondNode.setPos(-8,-53,18)
        self.diamondCS = self.diamondNode.attachNewNode(CollisionNode('diamond'))
        self.diamondCS.node().addSolid(CollisionSphere(0,0,0,5))
        #self.diamondCS.show()
        return None
    def doDiamondEvent(self):
        if( self.diamondEvent == False):
            self.diamondNode.removeNode()
            self.parent.soundMan.playCountdown()
            taskMgr.add(self.coundDownTask,"countDownTask")
            self.loadExitDoorEvent()
            print "diamond Event"
            self.parent.diamond.hide()
            self.parent.soundMan.playBGMusicStop()
            self.diamondEvent = True
        
        
        
        return None
    def loadExitDoorEvent(self):
        self.doorNode = render.attachNewNode('doorNode')
        self.doorNode.setPos(-100,-52,18)
        self.doorCS = self.doorNode.attachNewNode(CollisionNode('door'))
        self.doorCS.node().addSolid(CollisionSphere(0,0,0,3))
        
        #self.doorCS.show()
        return None
    
    def doExitDoorEvent(self):
        if(self.exitDoorEvent == False):
            self.doorNode.removeNode()
            self.gameOver = True
            self.gameOverDead = False
            self.exitDoorEvent = True
            self.parent.soundMan.playCountdownStop()
        return None
    def doRatCaught(self):
        print "you're caught"
        self.parent.enemyMan.sendToLalaLand()
        self.gameOver = True
        self.gameOverCaught = True
        self.parent.soundMan.playCountdownStop()
        self.parent.soundMan.playBGMusicStop()
        self.parent.soundMan.stopRoofConversation()
        return None
        
    def coundDownTask(self, task):
        
        
        if (task.time < 72 and self.gameOver == False):
            return Task.cont
        else:
            self.gameOver = True
            self.gameOverDead = True
            print "game over"
            return Task.done
        
    def checkGameOverTask(self, task):
        if(self.gameOver == False):
            return Task.cont
        elif(self.gameOver == True and self.gameOverCaught == True):
            self.parent.screens.capturedScreen()
            self.parent.soundMan.playYouLose()
            return Task.done
        elif(self.gameOver == True and self.gameOverDead == True):
            self.parent.screens.deadScreen()
            return Task.done
        elif(self.gameOver == True and self.gameOverDead == False and self.gameOverCaught == False):
            self.parent.screens.successScreen()
            self.parent.soundMan.playYouWin()
            return Task.done