# Author: Darrell Christmas
# Last Updated: 10/01/08

from direct.task.Task import Task
from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import *
MEDIAPATH="../video/"
SOUNDPATH = "../audio/music/"

class Screens(DirectObject):
    def __init__(self, parentObject):
       
        self.parent = parentObject
        self.introMoviePlayed = False
        self.caughtPlayed = False
        self.safePlayed = False
        self.diedPlayed = False
        self.skip = False
        return None

    
    
    def skipIntro(self):
        self.skip = True
        return None
    
    def introMovie(self):
      self.acceptOnce("enter", self.skipIntro)
      file = MEDIAPATH+"paperspinning.avi"
      audio = SOUNDPATH+"paperspinning.mp3"
      self.tex = loader.loadTexture(file)
      self.sound=loader.loadSfx(audio)
      cm = CardMaker("My Fullscreen Card");
      cm.setFrameFullscreenQuad()
      cm.setUvRange(self.tex)
      self.card = NodePath(cm.generate())
      self.card.reparentTo(render2d)
      self.card.setTexture(self.tex)
      
      self.tex.synchronizeTo(self.sound)
      self.sound.play()
      
      taskMgr.add(self.movieTask,"movieTask")
  
    def movieTask(self, task):
        if (task.time < 10 and self.skip == False):
            return Task.cont
        else:  
            self.parent.loadGame()
            self.introMoviePlayed = True
            self.sound.stop()
            self.card.detachNode()
            
            return Task.done

    def successScreen(self):
      file = MEDIAPATH+"winScreen.jpg"
      self.tex = loader.loadTexture(file)
      cm = CardMaker("My Fullscreen Card");
      cm.setFrameFullscreenQuad()
      cm.setUvRange(self.tex)
      self.card = NodePath(cm.generate())
      self.card.reparentTo(render2d)
      self.card.setTexture(self.tex)
      return None
  
    def capturedScreen(self):
      file = MEDIAPATH+"loseRat.jpg"
      self.tex = loader.loadTexture(file)
      cm = CardMaker("My Fullscreen Card");
      cm.setFrameFullscreenQuad()
      cm.setUvRange(self.tex)
      self.card = NodePath(cm.generate())
      self.card.reparentTo(render2d)
      self.card.setTexture(self.tex)
      return None
  
    def deadScreen(self):
      file = MEDIAPATH+"loseExplode.jpg"
      self.tex = loader.loadTexture(file)
      cm = CardMaker("My Fullscreen Card");
      cm.setFrameFullscreenQuad()
      cm.setUvRange(self.tex)
      self.card = NodePath(cm.generate())
      self.card.reparentTo(render2d)
      self.card.setTexture(self.tex)
      return None
    
    