# Author: Travis Hawk aka Awesomesauce Himself
# Editor: Brent "Hail To The King" Hunter


from pandac.PandaModules import *
from direct.actor.Actor import Actor
from direct.showbase.DirectObject import DirectObject
import random



class SoundManager(DirectObject):
    def __init__(self):
        self.bgMusic = base.loadMusic('../audio/music/lechamp.mp3')
        self.bgMusic.setVolume(.1)
        self.bgMusic.setLoopCount(0)
        self.playBGMusic()
        
        self.roofConversation = base.loadSfx('../audio/sfx/VOroof.mp3')
        self.roofConversation.setVolume(.8)
        self.roofConversation.setLoopCount(1)
        #self.playRoofConversation()
        
        self.ventConversation1 = base.loadSfx('../audio/sfx/VOventsConvo1.mp3')
        self.roofConversation.setVolume(.8)
        self.roofConversation.setLoopCount(1)
        
        self.ventConversation2 = base.loadSfx('../audio/sfx/VOventsConvo2.mp3')
        self.roofConversation.setVolume(.8)
        self.roofConversation.setLoopCount(1)
        
        self.ventConversation3 = base.loadSfx('../audio/sfx/VOventsConvo3.mp3')
        self.roofConversation.setVolume(.8)
        self.roofConversation.setLoopCount(1)
        
        self.roofAlert5 = base.loadSfx('../audio/sfx/VOalerted5floor.mp3')
        self.roofAlert5.setVolume(.8)
        self.roofAlert5.setLoopCount(1)
        
        self.roofAlert4 = base.loadSfx('../audio/sfx/VOalerted4floor.mp3')
        self.roofAlert4.setVolume(.8)
        self.roofAlert4.setLoopCount(1)
        
        self.roofAlert3 = base.loadSfx('../audio/sfx/VOalerted3floor.mp3')
        self.roofAlert3.setVolume(.8)
        self.roofAlert3.setLoopCount(1)
        
        self.roofAlert2 = base.loadSfx('../audio/sfx/VOalerted2floor.mp3')
        self.roofAlert2.setVolume(.8)
        self.roofAlert2.setLoopCount(1)
        
        self.roofAlert1 = base.loadSfx('../audio/sfx/VOalerted1floor.mp3')
        self.roofAlert1.setVolume(.8)
        self.roofAlert1.setLoopCount(1)
        
        self.ventAlert5 = base.loadSfx('../audio/sfx/VOalerted5vents.mp3')
        self.ventAlert5.setVolume(.8)
        self.ventAlert5.setLoopCount(1)
        
        self.ventAlert4 = base.loadSfx('../audio/sfx/VOalerted4vents.mp3')
        self.ventAlert4.setVolume(.8)
        self.ventAlert4.setLoopCount(1)
        
        self.ventAlert3 = base.loadSfx('../audio/sfx/VOalerted3vents.mp3')
        self.ventAlert3.setVolume(.8)
        self.ventAlert3.setLoopCount(1)
        
        self.ventAlert2 = base.loadSfx('../audio/sfx/VOalerted2vents.mp3')
        self.ventAlert2.setVolume(.8)
        self.ventAlert2.setLoopCount(1)
        
        self.ventAlert1 = base.loadSfx('../audio/sfx/VOalerted1vents.mp3')
        self.ventAlert1.setVolume(.8)
        self.ventAlert1.setLoopCount(1)
        
        #self.countdown = base.loadSfx('../audio/sfx/VObigRatsyCountdown.mp3')
        #self.countdown.setVolume(.8)
        #self.countdown.setLoopCount(1)
        
    	
    	
    	self.countdownMusic = base.loadSfx('../audio/music/escapeCountdown.mp3')
        self.countdownMusic.setVolume(.8)
        self.countdownMusic.setLoopCount(1)
        
        self.captureAlert1 = base.loadSfx('../audio/sfx/VOcapturedFloor1.mp3')
        self.ventAlert1.setVolume(.8)
        self.ventAlert1.setLoopCount(1)
        
        self.captureAlert2 = base.loadSfx('../audio/sfx/VOcapturedFloor2.mp3')
        self.captureAlert2.setVolume(.8)
        self.captureAlert2.setLoopCount(1)
        
        self.captureAlertVent1 = base.loadSfx('../audio/sfx/VOcapturedVents1.mp3')
        self.captureAlertVent1.setVolume(.8)
        self.captureAlertVent1.setLoopCount(1)
        
        self.captureAlertVent2 = base.loadSfx('../audio/sfx/VOcapturedVents2.mp3')
        self.captureAlertVent2.setVolume(.8)
        self.captureAlertVent2.setLoopCount(1)
        
        self.youWin = base.loadSfx('../audio/sfx/youWin.mp3')
        self.youWin.setVolume(.8)
        self.youWin.setLoopCount(1)
        
        self.youLose = base.loadSfx('../audio/sfx/youLose.mp3')
        self.youLose.setVolume(.8)
        self.youLose.setLoopCount(1)
   # def setSound(self,sound):
    #    self.sound = sound
    def playBGMusic(self):
        self.bgMusic.play()
        return None
    
    def playBGMusicStop(self):
        if self.bgMusic.status() == 2:
            self.bgMusic.stop()
        return None
    
    def playCountdownStop(self):
        if self.countdownMusic.status() == 2:
            self.countdownMusic.stop()
        return None
    
    def playRoofConversation(self):
        #self.roofConvo = render.attachNewNode("conversation")
        #self.roofConvo.attachNewNode(CollisionNode('colNode'))
        #self.roofConvo.setPos(0,0,100)
        #self.roofConvo.node().addSolid(CollisionSphere(0,0,3,2))
        #self.roofConvo.show()
        self.roofConversation.play()   
        return None
	
    def stopRoofConversation(self):
        if self.roofConversation.status() == 2:
	       self.roofConversation.stop()   
        return None
    
    def playEnemyAlert(self):
        playAlert = int(random.random()*5)
        alertList = [self.roofAlert1,self.roofAlert2,self.roofAlert3,self.roofAlert4,self.roofAlert5]
        alertName = alertList[playAlert]
        alertName.play()
        return None
        
    def playEnemyAlertVent(self):
        playAlert = int(random.random()*5)
        alertList = [self.ventAlert1,self.ventAlert2,self.ventAlert3,self.ventAlert4,self.ventAlert5]
        alertName = alertList[playAlert]
        alertName.play()
        return None
        
    def playVentConvo1(self):
        #plays event conversation 1
        self.ventConversation1.play()
        return None
    
    def playVentConvo2(self):
        #plays event conversation 2
        self.ventConversation2.play()
        return None
        
    def playVentConvo3(self):
        #plays event conversation 3
        self.ventConversation3.play()
        return None

    def playYouWin(self):
        #plays "you win" sfx
        self.youWin.play()
        return None

    def playYouLose(self):
    	#plays "you lose" sfx
    	self.youLose.play()
    	return None

    def playCountdown(self):
        #plays countdown event when diamond is grabbed
        #self.countdown.play()
        self.countdownMusic.play()
        return None
        
    def playEnemyCaptureVent(self):
        playAlert = int(random.random()*5)
        alertList = [self.captureAlertVent1,self.captureAlertVent1,self.captureAlertVent1,self.captureAlertVent2,self.captureAlertVent2]
        alertName = alertList[playAlert]
        alertName.play()
        return None
        
    def playEnemyCapture(self):
        playAlert = int(random.random()*5)
        alertList = [captureAlert2,captureAlert2,captureAlert2,captureAlert1,captureAlert1]
        alertName = alertList[playAlert]
        alertName.play()
        return None