# Author: Darrell Christmas
# Last Updated: 10/01/08
#Rat Enemy AI
#TODO: Make 3 Blip states to control when enemy gets hit by cheese or acorn, another to delete when far from player

from direct.showbase.DirectObject import DirectObject
from State import State

#patrol state handles branching for moving in and out of itself
class PatrolState(State):
    # Create a class variable that will hold a reference
    # to the single instance of PatrolState.

    instance = None
    class PatrolStateHelper:
        def __call__( self, *args, **kw ) :

            # If an instance of TestSingleton does not exist,
            # create one and assign it to TestSingleton.instance.

            if PatrolState.instance is None :
                object = PatrolState()
                PatrolState.instance = object

            # Return TestSingleton.instance, which should contain
            # a reference to the only instance of TestSingleton
            # in the system.

            return PatrolState.instance

    # Create a class level method that must be called to
    # get the single instance of TestSingleton.

    getInstance = PatrolStateHelper()

    def __init__(self):
        if not PatrolState.instance == None :
            raise RuntimeError, 'Only one instance of TestSingleton is allowed!'

    
    def Enter(self, entity):
        if(entity.isOnPatrolRoute == False):
            entity.gotoPatrolRoute()
        print "patroling"
    def Execute(self, entity):
        if (entity.getIsPlayerSeen() == False or entity.getisPlayerInRange() == False or entity.isWallInVision == True):
            entity.doPatrol()
            #print "patroling"
        elif (entity.getIsPlayerSeen() == True and entity.getisPlayerInRange() == True and entity.isWallInVision == False):
            nextState = PursuitState()
            entity.stateMachine.changeState(nextState)
            
        
    def Exit(self, entity):
        entity.doStopPatrol()
        print "no longer patroling"



#pursuit state handles branching for moving in and out of itself

class PursuitState(State):
    # Create a class variable that will hold a reference
    # to the single instance of PatrolState.

    instance = None
    class PursuitStateHelper:
        def __call__( self, *args, **kw ) :

            # If an instance of TestSingleton does not exist,
            # create one and assign it to TestSingleton.instance.

            if PursuitState.instance is None :
                object = PursuitState()
                PursuitState.instance = object

            # Return TestSingleton.instance, which should contain
            # a reference to the only instance of TestSingleton
            # in the system.

            return PursuitState.instance

    # Create a class level method that must be called to
    # get the single instance of TestSingleton.

    getInstance = PursuitStateHelper()
    
    def __init__(self):
        if not PursuitState.instance == None :
            raise RuntimeError, 'Only one instance of TestSingleton is allowed!'
    
    def Enter(self, entity):
        #if(entity.isOnPatrolRoute == False):
        #   entity.rat.gotoPatrolRoute()
        entity.parent.soundMan.playEnemyAlert()
        entity.doPursuit()
        print "enter pursuitState"
        return None
    
    def Execute(self, entity):
        if (entity.getIsPlayerSeen() == True and entity.getisPlayerInRange() == True and entity.isWallInVision == False):
            entity.doPursuit()
        elif (entity.getIsPlayerSeen() == False or entity.getisPlayerInRange() == False or entity.isWallInVision == True):
            nextState = PatrolState()
            entity.stateMachine.changeState(nextState)
        return None
    
    def Exit(self, entity):
        entity.doStopPursuit()
        print "no longer patroling"
        return None
                