from direct.showbase.DirectObject import DirectObject
from State import State

class StateMachine(DirectObject):
    def __init__(self, entity):
        self.owner = entity
        self.currentState = None
        self.previousState = None
        self.gobalState = None
        
    
    def update(self):
        if (self.gobalState != None):
            self.gobalState.Execute(self.owner)
        if (self.currentState != None):
            self.currentState.Execute(self.owner)
            
        
    def setCurrentState(self, newState):
        if (self.currentState == None):
            self.currentState = newState
            self.currentState.Enter(self.owner)
        else:
            self.currentState = newState
    def setPreviousState(self, newState):
        self.currentState = newState
    def setGlobalState(self, newState):
        self.gobalState = newState  
          
    def changeState(self, state):
        self.previousState = self.currentState
        self.currentState.Exit(self.owner)
        self.currentState = state
        self.currentState.Enter(self.owner)
    
    def revertToPreviousState(self):
        self.changeState(self.currentState)
    
    
    
    